aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorShiyang Ruan <ruansy.fnst@fujitsu.com>2021-12-14 16:19:12 +0800
committerEryu Guan <guaneryu@gmail.com>2021-12-25 21:30:15 +0800
commita2ba26e1ac18bd6e3cab04c7c86eb0d5d2bb3993 (patch)
tree39f2d27d0665eb06c42b89004c7c16d3c6e6bd4c
parent3472f99857df766a4778fb0c8dc06188d4644461 (diff)
downloadxfstests-dev-a2ba26e1ac18bd6e3cab04c7c86eb0d5d2bb3993.tar.gz
generic: add race test between reflink and mmap read
Test for races or FS corruption between reflink and mmap reading the target file. (MMAP version of generic/164,165) Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com> Reviewed-by: Eryu Guan <guaneryu@gmail.com> Signed-off-by: Eryu Guan <guaneryu@gmail.com>
-rw-r--r--common/reflink11
-rwxr-xr-xtests/generic/67072
-rw-r--r--tests/generic/670.out5
3 files changed, 88 insertions, 0 deletions
diff --git a/common/reflink b/common/reflink
index 1a29e5d186..76e9cb7d32 100644
--- a/common/reflink
+++ b/common/reflink
@@ -186,6 +186,17 @@ _read_range() {
$XFS_IO_PROG $xfs_io_args -f -c "pread -q -v $offset $len" "$file" | cut -d ' ' -f '3-18'
}
+# Prints a range of a file as a hex dump
+_mread_range() {
+ local file="$1"
+ local offset="$2"
+ local len="$3"
+ local xfs_io_args="$4"
+
+ $XFS_IO_PROG $xfs_io_args -f -c "mmap -rw 0 $((offset + len))" \
+ -c "mread -v $offset $len" "$file" | cut -d ' ' -f '3-18'
+}
+
# Compare ranges of two files
_compare_range() {
file1="$1"
diff --git a/tests/generic/670 b/tests/generic/670
new file mode 100755
index 0000000000..83fbd0b9bd
--- /dev/null
+++ b/tests/generic/670
@@ -0,0 +1,72 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. 670
+#
+# Test for races or FS corruption between reflink and mmap reading the
+# target file. (MMAP version of generic/164,165)
+#
+. ./common/preamble
+_begin_fstest auto clone
+
+_register_cleanup "_cleanup" BUS
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+_require_cp_reflink
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+finished_file=/tmp/finished
+rm -rf $finished_file
+mkdir $testdir
+
+loops=512
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize files"
+echo >> $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
+_cp_reflink $testdir/file1 $testdir/file3
+_scratch_cycle_mount
+
+fbytes() {
+ egrep -v '(61 61 61 61 61 61 61 61 61 61 61 61 61 61 61 61|62 62 62 62 62 62 62 62 62 62 62 62 62 62 62 62)'
+}
+
+reader() {
+ while [ ! -e $finished_file ]; do
+ _mread_range $testdir/file3 0 $((loops * blksz)) | fbytes
+ done
+}
+
+echo "Reflink and mmap reread the files!"
+reader &
+for i in `seq 1 2`; do
+ seq $nr_loops -1 0 | while read i; do
+ _reflink_range $testdir/file1 $((i * blksz)) \
+ $testdir/file3 $((i * blksz)) $blksz >> $seqres.full
+ [ $? -ne 0 ] && break
+ done
+ seq $nr_loops -1 0 | while read i; do
+ _reflink_range $testdir/file2 $((i * blksz)) \
+ $testdir/file3 $((i * blksz)) $blksz >> $seqres.full
+ [ $? -ne 0 ] && break
+ done
+done
+echo "Finished reflinking"
+touch $finished_file
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/670.out b/tests/generic/670.out
new file mode 100644
index 0000000000..13d2dd2c4f
--- /dev/null
+++ b/tests/generic/670.out
@@ -0,0 +1,5 @@
+QA output created by 670
+Format and mount
+Initialize files
+Reflink and mmap reread the files!
+Finished reflinking